import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.Duration;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.HashMap;

import online.mtapi.mt4.*;
import online.mtapi.mt4.Exception.ConnectException;
import online.mtapi.mt4.Exception.InvalidSymbolException;
import online.mtapi.mt4.Exception.TimeoutException;
import online.mtapi.mt4.Exception.TradeException;
import online.mtapi.mt4.log.Logger;
import online.mtapi.mt4.srv.PrimaryServer;
import online.mtapi.mt4.srv.SecondaryServer;
import online.mtapi.mt4.srv.Servers;

public class Main
{
    public static void main(String[] args) throws Exception {
        Logger.init("C:\\YandexDisk\\Tim\\java\\online.mtapi.mt4Inteli\\log");
        new Main().go();

        //ThreadPool.Executor.shutdown();
    }

    void go() throws Exception {
        //connectAsync();
        //multiThread();
        //many();
        //balance();
        //connectSrv();
        //speed2();
        //historyQuotes();
        //delete();
        //closeBy();
        marketOrder();
    }

    void marketOrder() throws InterruptedException, IOException, TimeoutException, ConnectException, InvalidSymbolException, TradeException {
        //QuoteClient qc = new QuoteClient(8475055, "ABcd1234", "dc-d01-06.mt4servers.net", 443);
        //QuoteClient qc = new QuoteClient(8110178, "qxTfjsi4", "52.22.84.239", 443);
        QuoteClient qc = new QuoteClient(8681572, "zy3ojco", "mt4-demopro-dc1.roboforex.com", 443);
        qc.Connect();
        String symbol = "EURUSD";
        OrderClientSafe oc = new OrderClientSafe(new OrderClient(qc));
        oc.OrderClient.OnOrderProgress.addListener(new OnProgress());
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        System.out.println("Sending...");
        double ask = qc.GetQuote(symbol).Ask;
        Order order = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0, 0, null, null);
        System.out.println("opened " + order.Ticket);
        double bid = qc.GetQuote(symbol).Bid;
        order = oc.OrderClose(order.Symbol, order.Ticket, order.Lots, bid, 0);
        System.out.println("closed " + order.Ticket);
    }

    void closeBy() throws Exception{

        String symbol = "EURUSD";

        //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(2060409011, "tmc011", "demo-1-dc-demo-hk.trademax.systems", 443);
        QuoteClient qc = new QuoteClient(524870, "z8x247kp", "47.244.129.146", 443);
        qc.Connect();
        OrderClient oc = new OrderClient(qc);
        Order order = oc.OrderSend(symbol, Op.BuyStop, 0.01, 1.2, 0, 0,0 ,null, 0, null);
        System.out.println("opened");
        Thread.sleep(2000);
        oc.OrderMultipleCloseBy(symbol);
    }

    void delete() throws Exception{

        String symbol = "EURUSD";

        //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(2060409011, "tmc011", "demo-1-dc-demo-hk.trademax.systems", 443);
        QuoteClient qc = new QuoteClient(524870, "z8x247kp", "47.244.129.146", 443);
        qc.Connect();
        OrderClient oc = new OrderClient(qc);
        Order order = oc.OrderSend(symbol, Op.BuyStop, 0.01, 1.2, 0, 0,0 ,null, 0, null);
        System.out.println("opened");
        Thread.sleep(2000);
        oc.OrderDelete(order.Ticket, order.Type, order.Symbol, order.Lots, order.OpenPrice);

    }

    void speed() throws IOException, TimeoutException, ConnectException, InvalidSymbolException, InterruptedException, TradeException {
        QuoteClient qc = new QuoteClient(524870, "z8x247kp", "47.244.129.146", 443);
        qc.Connect();
        String symbol = "EURUSDpro";
        OrderClientSafe oc = new OrderClientSafe(new OrderClient(qc));
        //oc.OrderClient.OnOrderProgress.addListener(new OnProgress());
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        for (int i = 0; i < 10; i++) {
            double ask = qc.GetQuote(symbol).Ask;
            DateFormat formatter = new SimpleDateFormat("HH:mm:ss.SSS");
            System.out.println(formatter.format(new Date()));
            Order order = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0, 0, null, null);
            System.out.println("opened " + formatter.format(new Date()));
            double bid = qc.GetQuote(symbol).Bid;
            order = oc.OrderClose(order.Symbol, order.Ticket, order.Lots, bid, 0);
            System.out.println("closed " + formatter.format(new Date()));
        }
    }
    void speed2() throws IOException, TimeoutException, ConnectException, InvalidSymbolException, InterruptedException, TradeException {
        QuoteClient qc = new QuoteClient(524870, "z8x247kp", "47.244.129.146", 443);
        qc.Connect();
        String symbol = "EURUSDpro";
        OrderClientSafeCmnt oc = new OrderClientSafeCmnt(new OrderClient(qc));
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        for (int i = 0; i < 10; i++) {
            double ask = qc.GetQuote(symbol).Ask;
            LocalDateTime start = LocalDateTime.now();
            Order order = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0, 0, 0, null);
            System.out.println("opened " + Duration.between(start, LocalDateTime.now()).toMillis());
            double bid = qc.GetQuote(symbol).Bid;
            start = LocalDateTime.now();
            order = oc.OrderClose(order.Symbol, order.Ticket, order.Lots, bid, 0);
            System.out.println("closed " + Duration.between(start, LocalDateTime.now()).toMillis());
        }
    }

    void many() throws InterruptedException, IOException, TimeoutException, ConnectException, InvalidSymbolException, TradeException {
        //QuoteClient qc = new QuoteClient(8475055, "ABcd1234", "dc-d01-06.mt4servers.net", 443);
        QuoteClient qc = new QuoteClient(8110178, "qxTfjsi4", "52.22.84.239", 443);
        qc.Connect();
        String symbol = "EURUSD";
        OrderClientSafe oc = new OrderClientSafe(new OrderClient(qc));
        oc.OrderClient.OnOrderProgress.addListener(new OnProgress());
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        System.out.println("Sending...");
        for (int i = 0; i < Integer.MAX_VALUE; i++) {
            if (!qc.Connected()) {
                Thread.sleep(1000);
                continue;
            }
            double ask = qc.GetQuote(symbol).Ask;
            Order order;
            try {
                order = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0, 0, null, null);
                System.out.println("opened " + order.Ticket);
            } catch (TimeoutException e) {
                e.printStackTrace();
                continue;
            }
            double bid = qc.GetQuote(symbol).Bid;
            try {
                order = oc.OrderClose(order.Symbol, order.Ticket, order.Lots, bid, 0);
                System.out.println("closed " + order.Ticket);
            } catch (TimeoutException e) {
                e.printStackTrace();
                continue;
            }
//Thread.sleep(100);
        }
    }

    void  onConnect() throws InterruptedException, IOException, TimeoutException, ConnectException, InvalidSymbolException {
        String symbol = "EURUSD";
        //QuoteClient qc = new QuoteClient(57566476, "xx4mdsu", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(1117, "abc111", "103.75.3.168", 443);
        //QuoteClient qc = new QuoteClient(520212,"a12345678","103.6.130.248",4433);
        //qc.PathForSavingSrv = "C:\\YandexDisk\\Tim\\java\\online.mtapi.mt4Inteli";
        QuoteClient qc = new QuoteClient(70120, "hat7nnb", "dev.divisafx.com", 443);
        qc.OnQuote.addListener(new OnQuote());
        qc.Connect();
        System.out.println("AccountBalance = " + qc.AccountBalance());
        qc.Subscribe("EURUSD");
        //double bal = qc.AccountBalance();
        //qc.Disconnect();
    }

    void multiThread() throws InterruptedException, IOException, TimeoutException, ConnectException, InvalidSymbolException {

        //QuoteClient qc = new QuoteClient(57566476, "xx4mdsu", "88.212.244.84", 1951);
        QuoteClient qc = new QuoteClient(8475055, "ABcd1234", "dc-d01-06.mt4servers.net", 443);
        qc.Connect();
        String symbol = "EURUSD";
        OrderClient oc = new OrderClient(qc);
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        double ask = qc.GetQuote(symbol).Ask;
        System.out.println("Sending...");
        for (int j = 0; j < 100; j++) {


            for (int i=0; i<40; i++)
            {
                (new Thread(new Runnable(){
                    public void run(){

                        try {
                            Order order = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0,0 ,"order_comment",
                                    0, null);
                            double bid = qc.GetQuote(symbol).Bid;
                            System.out.println("opened " + order.Ticket );
                            order = oc.OrderClose(order.Symbol, order.Ticket, order.Lots, bid, 0);
                            System.out.println("closed " + order.Ticket );
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                })).start();
                Thread.sleep(5000);

            }
        }
        //qc.Disconnect();
    }

    HashMap<Integer, LocalDateTime> OpenTime = new HashMap<Integer, LocalDateTime>();


    LocalDateTime toLocalTime(LocalDateTime currentServerTime, LocalDateTime serverTime)
    {

        int dif = (int)Duration.between(currentServerTime, LocalDateTime.now()).toMinutes();
        return serverTime.plusMinutes(dif);
    }

    void quotes() throws Exception {

        String symbol = "EURUSD";
        //QuoteClient qc = new QuoteClient(57852857, "in3fmji", "88.212.244.84", 1951);
        QuoteClient qc = new QuoteClient(520212, "a12345678", "103.6.130.248", 4433);
        OnQuote listener =  new OnQuote();
        qc.OnDisconnect.addListener(new OnDisconnect());
        qc.Connect();
        double min = (double)qc.GetSymbolGroupParams("EURUSD").lot_min / 100;
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        LocalDateTime local = toLocalTime(qc.ServerTime(), qc.GetQuote(symbol).Time);

        qc.OnQuote.addListener(listener);
        System.out.println("addListener");
        Thread.sleep(10000);
        //qc.Unsubscribe(symbol);
        qc.OnQuote.removeListener(listener);
        System.out.println("removeListener");
        for (QuoteEventHandler onquote: qc.OnQuote.listeners()) {
            qc.OnQuote.removeListener(onquote);
        }
    }

    class OnDisconnect implements DisconnectEventHandler
    {
        @Override
        public void invoke(Object sender, DisconnectEventArgs args)
        {
            System.out.println("Disconnect");
            QuoteClient qc = (QuoteClient) sender;
            if(args.Exception != null) {
                System.out.println(qc.AccountBalance() + args.Exception.getMessage());
                args.Exception.printStackTrace();
            }
        }
    }

    void market2() throws Exception{

        Logger.init("C:\\YandexDisk\\Tim\\java\\online.mtapi.mt4Inteli\\log");
        String symbol = "EURUSD";

        //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
        QuoteClient qc = new QuoteClient(2060409011, "tmc011", "demo-1-dc-demo-hk.trademax.systems", 443);
        qc.Connect();
        OrderClient oc = new OrderClient(qc);
        //Order order = oc.OrderSend(symbol, Op.Buy, 1, 0, 0, 0,0 ,null, 0, null);
        //Order order = oc.OrderSend(symbol, Op.Buy, 1, 58.39, 0, 0,0 ,"order_comment",0, LocalDateTime.MIN);

        //System.out.println("Ticket " + order.Ticket);
//        qc.OnQuote.addListener(new OnQuote());
//        qc.OnOrderUpdate.addListener(new OnUpdate());
//
//
//
//        for (Order order : qc.GetOpenedOrders()) {
//            System.out.println("Opened Order = " + order.toString() + "," + order.Lots + "," + order.ClosePrice);
//        }
//
//        System.out.println("Connected. Balance = " + qc.AccountBalance());
//        qc.Subscribe(symbol);
//
//        oc.OnOrderProgress.addListener(new OnProgress());

        //double ask = qc.GetQuote(symbol).Ask;
        //BigDecimal askPrice = BigDecimal.valueOf(ask);
        //System.out.println("Ask Price = " + askPrice);
//                Order sell = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0, 0);

    }

    //String symbol = "EURUSD";
    //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
    //QuoteClient qc = new QuoteClient(925866698, "a12345678", "103.105.58.181", 443);
    //QuoteClient qc = new QuoteClient(846902, "Aa123456", "47.112.103.96", 443);
    //QuoteClient qc = new QuoteClient(8475055, "ABcd1234", "dc-d01-06.mt4servers.net", 443);
    //QuoteClient qc = new QuoteClient(8110178, "qxTfjsi4", "52.22.84.239", 443);
    //QuoteClient qc = new QuoteClient(6313942, "u38715165", "18.163.157.66", 450);
    //qc.OnDisconnect.addListener(new OnDisconnect());
    public void connectAsync() throws InterruptedException, IOException, TimeoutException, ConnectException {
        QuoteClient qc1 = new QuoteClient(8169338, "Aa660906", "mt4trial2.exness.com", 443);
        qc1.OnConnect.addListener(new OnConnect());
        QuoteClient qc2 = new QuoteClient(8475055, "ABcd1234", "dc-d01-06.mt4servers.net", 443);
        qc2.OnConnect.addListener(new OnConnect());
        qc1.ConnectAsync();
        qc2.ConnectAsync();
    }

    class OnConnect implements ConnectEventHandler {
        @Override
        public void invoke(Object sender, ConnectEventArgs args) {
            QuoteClient qc = (QuoteClient) sender;
            if(args.Exception != null)
                System.out.println(qc.AccountName() + " " + args.Exception);
            else {
                System.out.println(qc.AccountName() +  " connected. Balance = " + qc.AccountBalance());
            }
        }
    }

    public void  balance() throws InterruptedException, IOException, TimeoutException, ConnectException {
        String symbol = "EURUSD";
        //QuoteClient qc = new QuoteClient(57566476, "xx4mdsu", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(1117, "abc111", "103.75.3.168", 443);
        //QuoteClient qc = new QuoteClient(520212,"a12345678","103.6.130.248",4433);
        //QuoteClient qc = new QuoteClient(70120, "hat7nnb", "dev.divisafx.com", 443);
        //qc.PathForSavingSrv = "C:\\YandexDisk\\Tim\\java\\online.mtapi.mt4Inteli";
        //QuoteClient qc = new QuoteClient(8475055, "ABcd1234", "dc-d01-06.mt4servers.net", 443);
        //qc.OnQuote.addListener(new OnQuote());
        //QuoteClient qc = new QuoteClient(8169338, "Aa660906", "mt4trial2.exness.com", 443);
        //QuoteClient qc = new QuoteClient(1900176481, "x5672", "65.52.141.163", 444);
        QuoteClient qc = new QuoteClient(1005907138, "Abc123", "103.253.115.94", 443);
        qc.Connect();
        System.out.println("AccountProfit = " + qc.AccountProfit());
        System.out.println("AccountMargin = " + qc.AccountMargin());
        //qc.Subscribe("EURUSD");
        //double bal = qc.AccountBalance();
        qc.Disconnect();
    }

    void update() throws IOException, TimeoutException, ConnectException, InterruptedException {
        //QuoteClient qc = new QuoteClient(93117187, "hn2ktjh", "mt4demo.match-trade.com", 663);
        QuoteClient qc = new QuoteClient(2125295126, "b3wdchm", "dchk2.gmimarkets.com", 1940);
        //qc.OnQuote.addListener(new OnQuote());
        qc.OnOrderUpdate.addListener(new OnUpdate());
        qc.Connect();
        System.out.println("AccountBalance = " + qc.AccountBalance());
    }

    class OnUpdate implements OrderUpdateEventHandler {
        @Override
        public void invoke(Object sender, OrderUpdateEventArgs update) {
            System.out.println(update.Order.Type + update.Order.Symbol);
        }
    }

    void asyncOrder() throws InterruptedException, IOException, TimeoutException, ConnectException, InvalidSymbolException, TradeException {

        QuoteClient qc = new QuoteClient(57566476, "xx4mdsu", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(2060409011, "tmc011", "216.93.254.50", 443);
        //QuoteClient qc = new QuoteClient(93106352, "fxyf7ou", "mt4demo.match-trade.com", 663);
        //QuoteClient qc = new QuoteClient(50935535, "knc5535h", "188.165.52.39", 553);

        qc.OnQuote.addListener(new OnQuote());
        qc.Connect();
        boolean b = qc.IsDemoAccount();
        Servers srv = QuoteClient.LoadSrv("C:\\YandexDisk\\MTServerApi (2)\\NewBuild1170\\TestCore\\bin\\Debug\\netcoreapp2.1\\TradersWay-Demo.srv");

        String symbol = "EURUSD";
        OrderClient oc = new OrderClient(qc);
        oc.OnOrderProgress.addListener(new OnProgress());
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        double ask = qc.GetQuote(symbol).Ask;
        Order order = oc.OrderSend(symbol, Op.Buy, 0.01, ask, 0, 0,0 ,"order_comment",
                0, null);
        double bid = qc.GetQuote(symbol).Bid;
        System.out.println(order.Comment);
        oc.OrderCloseAsync(order.Symbol, order.Ticket, order.Lots, bid, 0);
    }

    class OnProgress implements OrderProgressEventHandler {
        @Override
        public void invoke(Object o, OrderProgressEventArgs args) {
            System.out.println(args.Type);
            if(args.Exception != null)
                System.out.println(args.Exception);
            //else
            //	System.out.println(args.TempID + " " + args.Order.Comment);
        }
    }

    void connectWithoutSrv() throws IOException, TimeoutException, ConnectException, InterruptedException {
        //QuoteClient qc = new QuoteClient(55967934, "ov2osqv", "88.212.244.84", 1951);
        //QuoteClient qc = new QuoteClient(520212,"a12345678","103.6.130.248",4433);
        QuoteClient qc = new QuoteClient(925866698,"a12345678","103.105.58.181",443);
        qc.Connect();
        System.out.println("Connected with IP address");
        //byte[] srv = qc.LatestSrv;
        //Servers servers = QuoteClient.LoadSrv(srv);
        //qc = Connect(servers.PrimaryServer, servers.SecondaryServers, 520212, "a12345678");
        //System.out.println("Connected with SRV");
    }

    QuoteClient Connect(PrimaryServer primary , SecondaryServer[] slaves, int user, String password) throws IOException {
        System.out.println("Connecting...");
        QuoteClient qc = new QuoteClient(user, password, primary.getHost(), primary.getPort());
        try {
            qc.Connect();
            return qc;
        } catch (Exception ex){
            System.out.println("Cannot connect to primary server: " + ex.getMessage());
            return ConnectSlaves(slaves, user, password);
        }
    }

    void connectSrv() {
        try {
            //Servers servers = QuoteClient.LoadSrv( "C:\\Users\\Administrator\\AppData\\Roaming\\MetaQuotes\\Terminal\\CE596B1DC3633300A2F2E6716F228114\\config\\UpWay-Live.srv");
            //C:\YandexDisk\MTServerApi (2)\NewBuild1170\TestCore\bin\Release\netcoreapp2.1\MetaQuotes-Demo.srv
            Servers servers = QuoteClient.LoadSrv( "C:\\Users\\User\\AppData\\Roaming\\MetaQuotes\\Terminal\\A280125158FA7DC3523CC3C7FA375A75\\config\\Pepperstone-Demo02.srv");
            QuoteClient qc = Connect(servers.PrimaryServer, servers.SecondaryServers, 8110178, "qxTfjsi4");
            System.out.println("Connected to server");
        } catch (Exception ex){
            System.out.println(ex.getMessage());
        }
    }



    QuoteClient ConnectSlaves(SecondaryServer[] servers, int user, String password) throws IOException {
        System.out.println("Connecting to slaves...");
        for(SecondaryServer server: servers)
        {
            QuoteClient qc = new QuoteClient(user, password, server.getHost(), server.getPort());
            try {
                qc.Connect();
                return qc;
            } catch (Exception ex) {
                System.out.println(ex.getMessage());
            }
        }
        throw new RuntimeException("Cannot connect to secondary servers");
    }

    void market() throws InterruptedException, IOException, TimeoutException, ConnectException, InvalidSymbolException, TradeException {
        String symbol = "XAUUSD";
        //QuoteClient qc = new QuoteClient(2090221607, "OJgYhOfEF8", "demo.mt4tickmill.com", 443);
        QuoteClient qc = new QuoteClient(70120, "hat7nnb", "dev.divisafx.com", 443);
        qc.Connect();
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        qc.Subscribe(symbol);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        OrderClient oc = new OrderClient(qc);
        //oc.OnOrderProgress.addListener(new OnProgress());
        Order sell = oc.OrderSend(symbol, Op.Sell, 0.1, qc.GetQuote(symbol).Bid, 10, 0,0 );
        System.out.println("sell ticket " + sell.Ticket + " " + sell.CreationTime);
        Order close = oc.OrderClose(sell.Symbol, sell.Ticket, sell.Lots, qc.GetQuote(symbol).Ask, 10);
        System.out.println("closed " + close.Profit + " " + close.CreationTime);
        qc.Disconnect();
        qc.OnDisconnect.removeAllListeners();
        ThreadPool.Executor.shutdown();
    }

    //class OnProgress implements OrderProgressEventHandler {
//		@Override
    //public void invoke(Object sender, OrderProgressEventArgs update) {
    //		System.out.println(update.Order.Type + " " + update.Order.Symbol + " " + update.Type);
//		}
    //}

    void test() {

        int success = 0;
        int fail = 0;
        for (int i = 0; true; i++) {
            System.out.println("i = " + i);
            try {
                int account = 2090221607;
                String password = "OJgYhOfEF8";
                QuoteClient qc = new QuoteClient(account, password, "demo.mt4tickmill.com", 443);
                process(qc, "EURUSD");
                //
                System.out.println("qc.Disconnect()");
                qc.Disconnect();
                success++;
                //ThreadPool.Executor.shutdown();
            } catch (Exception e) {
                e.printStackTrace();
                fail++;
            }
            System.out.println("success = " + success + ", fail = " + fail);
        }
    }

    void process(QuoteClient qc, String subscribe) throws Exception {
        //qc.OnQuote.addListener(onQuote);
        qc.Connect();
        System.out.println("Connected");
        qc.Subscribe(subscribe);
        //market(qc);
        historyOrders(qc);
        openedOrders(qc);
    }

    void historyOrders(QuoteClient qc) throws Exception {
        System.out.println("historyOrders");
        for (Order order : qc.DownloadOrderHistory(DateTime.plusDays(DateTime.now(), -10), DateTime.plusDays(DateTime.now(), 1))) {
        }
    }

    //
    void openedOrders(QuoteClient qc) throws IOException, TimeoutException, ConnectException {
        System.out.println("openedOrders");
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        for (Order order : qc.GetOpenedOrders()) {
        }

    }

    void historyOrders() throws Exception {
        QuoteClient qc = new QuoteClient(2090221607, "OJgYhOfEF8", "demo.mt4tickmill.com", 443);
        qc.Connect();
        System.out.println("Connected. Balance = " + qc.AccountBalance());

        for (Order order : qc.DownloadOrderHistory(DateTime.plusDays(DateTime.now(), -10),DateTime.now()))
            System.out.println(order.Ticket + " " + order.Symbol + " " + order.Type + " " + order.Profit);

    }

    void openedOrders() throws IOException, TimeoutException, ConnectException, InterruptedException {
        QuoteClient qc = new QuoteClient(2090221607, "OJgYhOfEF8", "demo.mt4tickmill.com", 443);
        qc.Connect();
        System.out.println("Connected. Balance = " + qc.AccountBalance());
        while(true)
        {
            for (Order order : qc.GetOpenedOrders())
                System.out.println(order.Ticket + " " + order.Symbol + " " + order.Type + " " + order.Profit);
            System.out.println("______________");
            Thread.sleep(2000);
        }
    }


    void historyQuotes() throws Exception {
        QuoteClient qc = new QuoteClient(846902, "Aa123456", "185.96.247.141", 443);
        qc.Connect();
        qc.Subscribe("EURUSD");
        while (qc.GetQuote("EURUSD") == null)
            Thread.sleep(1);
        System.out.println("Connected. Balance = " + qc.AccountBalance());

        for (String symbol: qc.Symbols()){
            System.out.println("---------------------------- " + symbol);
            for (Bar bar : qc.DownloadQuoteHistory(symbol, Timeframe.M1, qc.ServerTime().plusHours(-2), qc.ServerTime().plusHours(-1))) {
                System.out.println(bar.Time);
            }
        }
    }

//QuoteClient qc = new QuoteClient(2090221607, "OJgYhOfEF8", "demo.mt4tickmill.com", 443);
    //QuoteClient qc = new QuoteClient(2060409011, "tmc011", "mt4-live-2-dc-0.trademax.systems", 443);
//QuoteClient qc = new QuoteClient(524870, "z8x247kp", "47.244.129.146", 443);
//String symbol = "EURUSD";
//System.out.println(qc.ServerTime());
//qc.OnQuoteHistory.addListener(new OnQuoteHist());
    //qc.DownloadQuoteHistory("EURUSD", Timeframe.H1, LocalDateTime.now(), (short)100);

    class OnQuoteHist implements QuoteHistoryEventHandler {
        @Override
        public void invoke(Object o, QuoteHistoryEventArgs args) {
            System.out.println(args.Symbol + " " + args.TimeFrame);
            for (Bar bar : args.Bars)
                System.out.println(bar.Time + " " + bar.Open + " " + bar.Close);
        }
    }

    class OnQuote implements QuoteEventHandler
    {
        @Override
        public void invoke(Object sender, QuoteEventArgs args)
        {
            QuoteClient qc = (QuoteClient)sender;
//			try {
//				System.out.println(args + " " + qc.HighLow.getHigh(args.Symbol) + " " + qc.HighLow.getLow(args.Symbol) + " " + qc.HighLow.getSpread(args.Symbol)
//						+ " " + qc.HighLow.getTime(args.Symbol));
//			}
//			catch(InvalidSymbolException e)
//			{
//
//			}

        }
    }

    void run() throws IOException, InterruptedException, ConnectException, TimeoutException, InvalidSymbolException, TradeException {
        String symbol = "EURUSD";
        //QuoteClient qc = new QuoteClient(63253080, "h4dckcn", "mt4d05.fxcorporate.com", 443);
        //QuoteClient qc = new QuoteClient(36089, "cei7zxf",  "demo4newyork.evolve.markets", 443);
        //QuoteClient qc = new QuoteClient(36089, "cei7zxf",  "demo4newyork.evolve.markets", 443);
        //QuoteClient qc = new QuoteClient(1235146308, "n1uohjn", "82.192.76.142", 443);
        QuoteClient qc = new QuoteClient(2090221607, "OJgYhOfEF8", "demo.mt4tickmill.com", 443);
        qc.OnQuote.addListener(new OnQuote());
        qc.Connect();
        System.out.println("connected");
        qc.Subscribe(symbol);
        OrderClient oc = new OrderClient(qc);
        while (qc.GetQuote(symbol) == null)
            Thread.sleep(1);
        Order sell = oc.OrderSend(symbol, Op.Sell, 0.1, qc.GetQuote(symbol).Bid, 10, 0, 0, "2125258600_63253080_24908802", 0, null);
        System.out.println("sell ticket " + sell.Ticket);
        Order close = oc.OrderClose(sell.Symbol, sell.Ticket, sell.Lots, qc.GetQuote(symbol).Ask, 10);
        System.out.println("closed " + close.Profit);
//		OrderClient oc = new OrderClient(qc);
//		qc.Subscribe(symbol);
//		Thread.sleep(5000);
//		qc.Disconnect();
//		qc.Connect();
//		System.out.println("connected");
//		Thread.sleep(5000);
////		while (qc.GetQuote(symbol) == null)
//			Thread.sleep(1);
//
//		Order sell = oc.OrderSend(symbol, Op.Sell, 0.01, qc.GetQuote(symbol).Bid, 10, 0, 0, "2125258600_63253080_24908802", 0, LocalDateTime.MIN);
//		System.out.println("sell ticket " + sell.Ticket);


        //Logger.init("C:\\YandexDisk\\Tim\\java\\online.mtapi.mt4Inteli\\log");
        //QuoteClient.PathDecompress = "C:\\YandexDisk\\Tim\\java\\decompress";
        //Servers srv = QuoteClient.LoadSrv("C:\\YandexDisk\\MTServerApi (2)\\MT4 Server API Samples\\Test\\bin\\Debug\\tmp\\GerchikCo-Demo.srv");
        //QuoteClient qc = new QuoteClient(67611, "wx1yhpn", srv.PrimaryServer.getHost(), srv.PrimaryServer.getPort());
        //qc.PathForSavingSrv =   "C:\\YandexDisk\\MTServerApi (2)\\MT4 Server API Samples\\Test\\bin\\Debug\\tmp\\t";
        //int t = MT4Order.toMtTime(LocalDateTime.now());
        //LocalDateTime n = MT4Order.toNetTime(t);

//		 qc = new QuoteClient(36089, "cei7zxf",  "demo4newyork.evolve.markets", 443);
//		qc.OnOrderUpdate.addListener(new OnUpdate());
//    	qc.Connect();
//		System.out.println("Connected");
//		Thread.sleep(5000);
//		qc.Disconnect();
//		System.out.println("Disconnected");
//		Thread.sleep(5000);
//		qc.Connect();
//		System.out.println("Connected");
        //for(Order order : qc.GetOpenedOrders())
        //		System.out.println(order.Symbol + " " + order.OpenTime);
//		HighLow hl = new HighLow(qc);
//		String symbol = "BTCUSD";
//		for (int i = 0; i < 50; i++)
//		{
//			System.out.println(hl.getHigh(symbol) + " " +hl.getLow(symbol) + " " +hl.getSpread(symbol) + " " +hl.getTime(symbol) );
//			Thread.sleep(1000);
//		}
//		ThreadPool.Executor.shutdown();
//        for (String line : Files.readAllLines(Paths.get("C:\\YandexDisk\\Tim\\java\\online.mtapi.mt4Inteli\\acc.txt"))) {
//            String[] ar = line.split(" ");
//            start(Integer.parseInt(ar[0]), ar[1]);
//        }new Thread()
//    	{
//    		 public void run() {
//    			 MyServer server = new MyServer(user, pass);
//    			 while(true)
//    			 {
//    				 server.openOrder();
//    				 server.closeOrder();
//    				 try {
//						Thread.sleep(1000);
//					} catch (InterruptedException e) {
//						// TODO Auto-generated catch block
//						e.printStackTrace();
//					}
//    			 }
//    		 }
//    	}.start();
    }



    void start(int user, String pass)
    {
        new Thread()
        {
            public void run() {
                MyServer server = new MyServer(user, pass);
                while(true)
                {
                    server.openOrder();
                    server.closeOrder();
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                }
            }
        }.start();
    }
}


class MyServer
{
    QuoteClient QC;
    OrderClient OC;
    Order Ord;
    String symbol = "EURUSD";
    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");

    public MyServer(int user, String pass)
    {
        try
        {
            QC = new QuoteClient(user, pass,  "demo4newyork.evolve.markets", 443);
            QC.OnDisconnect.addListener(new OnDisconnect());
            QC.Connect();
            String symbol = "EURUSD";
            int spreadInPoints = QC.GetSymbolInfo(symbol).Spread;
            double pointValue = QC.GetSymbolInfo(symbol).Point;
            double spread = pointValue * spreadInPoints;
            System.out.println(spreadInPoints + " " + spread);
            //0 - means floating spread, in this case you can estimate spread on each tick
            while(QC.GetQuote(symbol) == null)
                Thread.sleep(1);
            System.out.println(QC.GetQuote(symbol).Bid);
            System.out.println(QC.GetQuote(symbol).Ask);
            spread = QC.GetQuote(symbol).Ask - QC.GetQuote(symbol).Bid;
            spreadInPoints = (int)(spread/ pointValue);
            System.out.println(spreadInPoints + " " + spread);

            OC = new OrderClient(QC);
            System.out.println(sdf.format(LocalDateTime.now()) + ": " + "Connected");
            openOrder();
        }
        catch(Exception ex)
        {
            System.out.println(ex.getMessage());
        }
    }

    class OnDisconnect implements DisconnectEventHandler
    {
        @Override
        public void invoke(Object sender, DisconnectEventArgs args)
        {
            if(args.Exception != null)
                args.Exception.printStackTrace();
        }
    }

    public void openOrder()
    {
        try
        {
            Ord = OC.OrderSend(symbol, Op.Buy, 0.1, 0, 100, 0, 0);//QC.GetQuote(symbol).Ask
            //System.out.println(sdf.format(LocalDateTime.now()) + ": " + Ord.Ticket + " opened");
        }
        catch(Exception ex)
        {
            System.out.println(ex.getMessage());
        }
    }

    public void closeOrder()
    {
        try
        {
            OC.OrderClose(Ord.Symbol, Ord.Ticket, Ord.Lots, 0, 100);//QC.GetQuote(Ord.Symbol).Bid
            //System.out.println(sdf.format(LocalDateTime.now()) + ": " + Ord.Ticket + " closed");
        }
        catch(Exception ex)
        {
            System.out.println(ex.getMessage());
        }
    }
}

/*
import java.io.IOException;

import online.mtapi.mt4.OrderClient;
import online.mtapi.mt4.OrderUpdateEventArgs;
import online.mtapi.mt4.OrderUpdateEventHandler;
import online.mtapi.mt4.QuoteClient;
import online.mtapi.mt4.TimeoutException;

class HelloWorld {
	QuoteClient qcMaster;

	QuoteClient qcSlave;
	OrderClient ocSlave;

    public static void main(String[] args) throws IOException, InterruptedException, ConnectException, TimeoutException, InvalidSymbolException
    {
    	new HelloWorld().run();
    }

    void run() throws IOException, InterruptedException, ConnectException, TimeoutException, InvalidSymbolException
    {
    	QuoteClient.PathDecompress = "C:\\YandexDisk\\Tim\\java\\decompress";
    	//QuoteClient qc = new QuoteClient(7782348, "tl2cixi", "13.71.157.80", 443);
    	QuoteClient qc = new QuoteClient(36089, "cei7zxf",  "demo4newyork.evolve.markets", 443);
    	//QuoteClient qc = new QuoteClient(7782377, "zll3xog",  "13.71.157.80", 443);
    	qc.Connect();
    	OrderClient oc = new OrderClient(qc);
    	oc.OnOrderProgress.addListener(new OnProgress());
    	String symbol = "EURUSD";
    	qc.Subscribe(symbol);
//    	for(Order order:qc.GetOpenedOrders())
//    	{
//    		oc.OrderCloseAsync(order.Symbol, order.Ticket, order.Lots, qc.GetQuote(order.Symbol).Ask, 100);
//    	}
    	//Order order =
    	try
    	{
    		for(int i=0; i<1; i++)
    		{
    			oc.OrderSend( symbol, Op.Buy, 0.1, qc.GetQuote(symbol).Ask, 100, 0, 0);
    			//System.out.print(id + " ");
    		}
    	}
    	catch(ServerException ex)
    	{
    		System.out.println(ex.getMessage());
    		System.out.println(ex.Code);
    	}
    	catch(TimeoutException ex)
    	{
    		System.out.println(ex.getMessage());
    	}
    	catch(Exception ex)
    	{
    		System.out.println(ex.getMessage());
    	}

    	//oc.OrderSendAsync( symbol, Op.Buy, 0.1, qc.GetQuote(symbol).Ask, 100, 0,	0);

    	//oc.Order order01 = oc.OrderSend( symbol, Op.Buy, 0.1, qc.GetQuote(symbol).Ask, 100, 0,	0);
    	//System.out.println(order01.Ticket);
    	for(int i=0; i<10000; i++)
    	{
    		//System.out.println(qc.AccountEquity());
    		Thread.sleep(1000);
    	}
    	qcMaster = new QuoteClient(36028, "i4gouua", "demo4newyork.evolve.markets", 443);

    	qcSlave = new QuoteClient(36029, "payh7wq", "demo4newyork.evolve.markets", 443);
        ocSlave = new OrderClient(qcSlave);

    	try
    	{
    		qcMaster.Connect();
    		qcSlave.Connect();
    	}
		catch (Exception e)
    	{
			System.out.println("Cannot connect " + e.getMessage());
		}
    	System.out.println("Account balance=" + qcMaster.AccountBalance());
    	qcMaster.OnOrderUpdate.addListener(new OnUpdate());
    }

    class OnProgress implements OrderProgressEventHandler
    {
		@Override
		public void invoke(Object sender, OrderProgressEventArgs args)
		{
			if(args.Exception != null)
			{
				System.out.println(args.TempID + ": " + args.Exception.getMessage());
			}
		}
    }

    class OnUpdate implements OrderUpdateEventHandler
    {
    	@Override
    	public void invoke(Object sender, OrderUpdateEventArgs update)
    	{
    		System.out.println(update.Order.Type + update.Order.Symbol);
    		try {
				ocSlave.OrderSend(
						update.Order.Symbol,
						update.Order.Type,
						update.Order.Lots,
						update.Order.OpenPrice,
						100,
						update.Order.StopLoss,
						update.Order.TakeProfit
						);
			} catch (TimeoutException e)
    		{

			}
    	}
    }
}

*/
